FROM python:3.8-alpine as python-base

    # python
ENV PYTHONUNBUFFERED=1 \
    # prevents python creating .pyc files
    PYTHONDONTWRITEBYTECODE=1 \
    \
    # pip
    PIP_NO_CACHE_DIR=off \
    PIP_DISABLE_PIP_VERSION_CHECK=on \
    PIP_DEFAULT_TIMEOUT=100 \
    \
    # poetry
    # https://python-poetry.org/docs/configuration/#using-environment-variables
    POETRY_VERSION=1.1.4 \
    # make poetry install to this location
    POETRY_HOME="/opt/poetry" \
    # make poetry create the virtual environment in the project's root
    # it gets named `.venv`
    POETRY_VIRTUALENVS_IN_PROJECT=true \
    # do not ask any interactive question
    POETRY_NO_INTERACTION=1 \
    \
    # paths
    # this is where our requirements + virtual environment will live
    PYSETUP_PATH="/opt/pysetup" \
    VENV_PATH="/opt/pysetup/.venv" \
    APP_VERSION="4.0.0"

ENV PACKAGE="chained_ci_mqtt_trigger-$APP_VERSION-py3-none-any.whl" \
    PATH="$VENV_PATH/bin:$PATH"

# prepend poetry and venv to path
ENV PATH="$POETRY_HOME/bin:$VENV_PATH/bin:$PATH"


# `builder-base` stage is used to build deps + create our virtual environment
FROM python-base as builder-base

RUN apk add --no-cache curl
# install poetry - respects $POETRY_VERSION & $POETRY_HOME
RUN curl -sSL https://raw.githubusercontent.com/sdispater/poetry/master/get-poetry.py | python

# copy project requirement files here to ensure they will be cached.
WORKDIR $PYSETUP_PATH
COPY poetry.lock pyproject.toml ./

# install runtime deps - uses $POETRY_VIRTUALENVS_IN_PROJECT internally
RUN poetry install --no-dev

WORKDIR /sources
COPY . .
RUN poetry build
RUN ls /sources/dist/$PACKAGE

FROM python-base

COPY --from=builder-base $PYSETUP_PATH $PYSETUP_PATH
COPY --from=builder-base /sources/dist/$PACKAGE /dist/$PACKAGE
RUN ls /dist
RUN $VENV_PATH/bin/pip install --no-deps /dist/$PACKAGE

COPY etc/chained_ci_mqtt_trigger.conf /etc/chained-ci-mqtt-trigger.conf

ENTRYPOINT ["chained-ci-mqtt-trigger"]
CMD ["/etc/chained-ci-mqtt-trigger.conf"]
